# (c) Roland van Laar

from django.conf.urls.defaults import *
from conf.exodus.models import *

node_dict  = {
    'queryset': Node.objects.all(),
}

urlpatterns = patterns('',

	# views
	(r'^$', 'django.views.generic.simple.direct_to_template', {'template': 'exodus/index.html'}) ,
	(r'^nodelist/$', 'django.views.generic.list_detail.object_list', node_dict),
	(r'^(?P<object_id>\d+)/node/$', 'django.views.generic.list_detail.object_detail', node_dict),

	# config urls
	(r'^(?P<object_id>\d+)/dhcp.conf/$', 'conf.exodus.views.conf_dhcp_conf'),
	(r'^(?P<object_id>\d+)/named.conf/$', 'conf.exodus.views.conf_named_conf'),
	(r'^(?P<object_id>\d+)/rc.node.local/$', 'conf.exodus.views.conf_rc_node_local'),
	(r'^(?P<object_id>\d+)/resolv.conf/$', 'conf.exodus.views.conf_resolv_conf'),


	# add urls
	(r'^addlocation/$', 'conf.exodus.views.addlocation'),
	(r'^addnode/$', 'conf.exodus.views.addnode'),
	(r'^addnic/$', 'conf.exodus.views.addnic'),
	(r'^addinterlink/$', 'conf.exodus.views.addinterlink'),
	(r'^addomni/$', 'conf.exodus.views.addomni'),

	(r'^static/(.*)$', 'django.views.static.serve', {'document_root': 
	 '/Users/rick/svn/wleiden/code/exodus/static'}),
)
